#include "stk.h"
#include "names.h"


int stk_window_ow, stk_window_oh;	// original window size
int stk_window_w, stk_window_h;		// current window size
int stk_window;				// openGL window ID
float stk_window_wr, stk_window_hr;	// ratio between current size and original size


int stkInitGlut( int argc, char *argv[], int window_w, int window_h, char *window_name, int fullscreen){
	stk_mouse_over_object = NULL;
	stk_window_w = stk_window_ow = window_w;
	stk_window_h = stk_window_oh = window_h;
	stk_window_wr = stk_window_hr = 1.0;

	stk_input_with_focus = NULL;

	stk_forms_head = NULL;

	glutInit(&argc, argv);
	glutInitWindowPosition(0, 0);
	glutInitWindowSize(window_w, window_h);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	if((stk_window = glutCreateWindow(window_name)) == GL_FALSE) return(0);
	if(fullscreen) glutFullScreen();

	glutKeyboardFunc(stkKey);
	glutSpecialFunc(stkSpecialKey);
	glutSpecialUpFunc(stkSpecialKeyUp);

	glutMouseFunc(stkMouseButton);
	glutMotionFunc(stkMouseActive);
	glutPassiveMotionFunc(stkMousePassive);
	glutEntryFunc(stkMouseEntry);

	glutReshapeFunc(stkResize);
	glutDisplayFunc(stkRedraw);

	stkResize(window_w, window_h);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	return(1);
}


void stkShutdown( ){
	while(stk_nr_forms) stkFreeForm(stk_forms_head);
}


void stkResize( int width, int height ){
	float ratio;
	stkObject *object;
	stkForm *form;
	int f, o;

	if(height == 0) height = 1;
	ratio = ((float)width) / ((float)height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, (GLint)width, (GLint)height);
	gluPerspective(45, ratio, 1, 500);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(width>>1,height>>1,0, width>>1,height>>1,-1, 0,1,0);

	stk_window_wr = ((float)width) / ((float)stk_window_ow);
	stk_window_hr = ((float)height) / ((float)stk_window_oh);
	stk_window_w = width;
	stk_window_h = height;

	f = stk_nr_forms;
	form = stk_forms_head;
	while(f){
		if((form->flags & STK_FLAGS_FORM_HAS_VIEW) && (form->flags & STK_FLAGS_VISIBLE)){
			o = form->nr_objects;
			while(o){
				o--;
				object = form->objects[o];
				if((object->type == STK_VIEWGL) && (object->VIEWGL_RESIZE != NULL)){
					glutSetWindow(object->VIEWGL_WINDOW);
					glutPositionWindow((int)(object->x * stk_window_wr) + 1,
						(int)((stk_window_oh - 1 - object->y - object->h)*stk_window_hr) + 1);
					glutReshapeWindow((int)((object->w)*stk_window_wr) -2,
							(int)((object->h)*stk_window_hr) -2);
				}
			}
		}
		f--;
		form = form->next;
	}
}


void stkRenderBegin( ){
	glutSetWindow(stk_window);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0,stk_window_ow,0,stk_window_oh, -1.0f,1.0f);

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	glLoadIdentity();
}


void stkRenderEnd(){
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();

	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();

	glutSwapBuffers();
}
