#include "stk.h"
#include "names.h"


stkObject *stkCreateObject( int type, stkForm *form, int x, int y, int w, int h, int nr_values ){
	stkObject *object;
	int nr_objects;

printf("stkCreateObject(): creating object @ (%d,%d), type = %d\n", x,y, type);

	if(form == NULL) return(NULL);

	object = (stkObject *)malloc(sizeof(stkObject));
	if(object != NULL){
		nr_objects = form->nr_objects;
		if(nr_objects == form->max_objects){
			form->max_objects += OBJECTS_PER_BLOCK;
			form->objects = (stkObject **)realloc((void *)(form->objects),
					sizeof(stkObject *)*(form->max_objects));
			if(form->objects == NULL){
				form->max_objects -= OBJECTS_PER_BLOCK;
				free(object);
				return(NULL);
			}
		}
		form->objects[nr_objects] = object;
		form->nr_objects++;

		object->flags = (char)(STK_FLAGS_VISIBLE | STK_FLAGS_ENABLED);
		object->type = type;
		object->form = form;
		object->x = x;
		object->y = y;
		object->w = w;
		object->h = h;

		object->v = (union o_data *)malloc(sizeof(union o_data)*nr_values);
	}
	return(object);
}


void stkShowObject( stkObject *object ){
	int window;

	if(object != NULL){
		object->flags |= (char)STK_FLAGS_VISIBLE;
		if(object->type == STK_VIEWGL){
			window = glutGetWindow();
			glutSetWindow(object->VIEWGL_WINDOW);
			glutShowWindow();
			glutSetWindow(window);
		}
	}
}


void stkHideObject( stkObject *object ){
	int window;

	if(object != NULL){
		object->flags &= (char)(~STK_FLAGS_VISIBLE);
		if(object->type == STK_VIEWGL){
			window = glutGetWindow();
			glutSetWindow(object->VIEWGL_WINDOW);
			glutHideWindow();
			glutSetWindow(window);
		}
	}
}


void stkEnableObject( stkObject *object ){
	if(object != NULL) object->flags |= (char)STK_FLAGS_ENABLED;
}


void stkDisableObject( stkObject *object ){
	if(object != NULL) object->flags &= (char)(~STK_FLAGS_ENABLED);
}


void stkSetObjectColor( stkObject *object, float red, float green, float blue ){
	if(object != NULL){
		object->flags |= (char)STK_FLAGS_COLOR;
		object->r = red;
		object->g = green;
		object->b = blue;
	}
}


void stkUnsetObjectColor( stkObject *object ){
	if(object != NULL) object->flags &= (char)(~STK_FLAGS_COLOR);
}
