#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <GL/glut.h>
#include <stk_theme.h>


int window_view;
float x,y;
stkObject *tb_vib, *cb_red, *cb_green, *cb_blue;
char *input_text;
TexFont *font;


void view_redraw( ){
	float s;
	double clip_equation[] = {0.0, 0.0, 0.0, 0.0};
	int width, ascent, descent;
	float text_x;

	glutSetWindow(window_view);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	

	if(!stkGetToggleButton(tb_vib)) s = (rand()/(RAND_MAX*1.0)-0.5)/50;
	else s = 0;

	glPushMatrix();
	glTranslatef(x+s,y+s,s);

	glColor3f(stkGetCheckbox(cb_red), stkGetCheckbox(cb_green), stkGetCheckbox(cb_blue));
	glBegin(GL_QUADS);
		glVertex3i(-1,-1,-5);
		glVertex3i( 1,-1,-5);
		glVertex3i( 1, 1,-5);
		glVertex3i(-1, 1,-5);
	glEnd();

	txfGetStringMetrics(stk_theme_font, input_text, strlen(input_text),
		&width, &ascent, &descent);
	text_x = width/200.0;

	glColor3f(0.5, 0.5, 0.5);
	glEnable(GL_TEXTURE_2D);
	glAlphaFunc(GL_GEQUAL, 0.0625);
	glEnable(GL_ALPHA_TEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glTranslatef(-text_x, -1.2, -4);
	glScalef(0.01, 0.01,0);
	txfRenderString(font, input_text, strlen(input_text));
	glDisable(GL_TEXTURE_2D);

	glPopMatrix();

	glutSwapBuffers();
}
void view_resize( int width, int height ){
	float ratio;

	if(height == 0) height = 1;
	ratio = ((float)width) / ((float)height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0,0, width,height);
	gluPerspective(45, ratio, 1, 500);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(0,0,0, 0,0,-1, 0,1,0);
}
void move_up( ){
	y+=0.1;
}
void move_down( ){
	y-=0.1;
}
void move_left( ){
	x-=0.1;
}
void move_right( ){
	x+=0.1;
}
void input_change( char *text ){
	input_text = text;
	view_redraw();
}
void quit( ){
	stkShutdown();
	exit(EXIT_SUCCESS);
}
void mouse_button( int button, int state, int x, int y ){
	if(state == GLUT_DOWN) printf("*** mouse clicked (%d, %d)\n", x, y);
}
void key_press( unsigned char key, int x, int y ){
	printf("*** key pressed (%c)\n", key);
}
int main( int argc, char *argv[] ){
	stkForm *form1, *form2;

	if(!stkInitGlut(argc, argv, 640, 480, "stk test-app", 0)){
		printf("ERROR: unable to create window\n");
		exit(EXIT_FAILURE);
	}
	stkThemeInit();

	x = y = 0.0;

	form1 = stkCreateForm(0,150, 640,330);
	stkEnableForm(form1);
//	stkHideForm(form1);
	stkCreateViewGL(form1, 5,155, 630,320, view_redraw, view_resize, &window_view);


	form2 = stkCreateForm(0,0, 640,150);
	stkEnableForm(form2);
	stkCreateButton(form2, 500,115, 80,30, move_up, "up", 1);
	stkCreateButton(form2, 440,80,  90,30, move_left, "left", 1);
	stkCreateButton(form2, 535,80, 90,30, move_right, "right", 1);
	stkCreateButton(form2, 500,45, 80,30, move_down, "down", 1);
	cb_red = stkCreateCheckbox(form2, 5,65, 25,25, NULL, 0);
	cb_green = stkCreateCheckbox(form2, 5,35, 25,25, NULL, 0);
	cb_blue = stkCreateCheckbox(form2, 5,5, 25,25, NULL, 1);
	stkSetObjectColor(stkCreateLabel(form2, 35,70, "red", 0.75), 1,0,0);
	stkSetObjectColor(stkCreateLabel(form2, 35,40, "green", 1), 0,1,0);
	stkSetObjectColor(stkCreateLabel(form2, 35,10, "blue", 1.5), 0,0,1);
	tb_vib = stkCreateToggleButton(form2, 5,115, 370,30, NULL,
			"disable vibration", "enable vibration", 0, 1);
	stkDisableObject(stkCreateButton(form2, 320,5, 315,30, NULL, "a disabled button", 1));
	stkSetObjectColor(stkCreateButton(form2, 220,5, 90,30, quit, "quit", 1.1), 1,0.5,0.5);


	input_text = stkGetInput(
		stkCreateInput(form2, 200,45, 200,30, input_change, "input", 15, 1) );
	

	glutSetWindow(window_view);
	glutIdleFunc(view_redraw);
	glutKeyboardFunc(key_press);
	glutMouseFunc(mouse_button);

	font = txfLoadFont("/usr/local/stk/default/default.txf");
	if (font == NULL) {
		printf("ERROR: unable to load font, default.txf\n");
	exit(EXIT_FAILURE);
	}
	txfEstablishTexture(font, 0, GL_TRUE);


printf("## starting glutMainLoop()\n");
	glutMainLoop();
	exit(EXIT_SUCCESS);
}
